module Primes where

-- Calculating primes with Eratosthenes

-- Sieve it!
sieve :: [Integer]-> [Integer]
sieve (p:ps) = p: sieve (filter (\q-> q `mod` p /= 0) ps)

-- All primes
allprimes :: [Integer]
allprimes = sieve [2..]

-- The first n primes
primes :: Int-> [Integer]
primes n = take n allprimes
